<template>
  <v-row justify="center">
    <v-dialog v-model="dialog" width="30em" persistent>
      <v-form v-model="valid" validate-on="blur">
        <v-card>
          <v-card-title>
            <span class="text-h5">Login</span>
          </v-card-title>
          <v-card-subtitle>
            Enter credentials
          </v-card-subtitle>
          <v-card-text>
              <v-container>
                <v-text-field label="Email" variant="solo" v-model="creds.username" :rules="emailRules"></v-text-field>
                <v-text-field label="Password" type="password" variant="solo" v-model="creds.password"></v-text-field>
              </v-container>
            </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn size="small" color="success" @click="login" variant="elevated" :disabled="!valid">Login</v-btn>
            <v-btn size="small" @click="dialog = false" variant="elevated">Cancel</v-btn>
          </v-card-actions>
        </v-card>
      </v-form>
    </v-dialog>
  </v-row>

  <v-snackbar v-model="loginFailed" timeout="3000">Login failed</v-snackbar>
</template>

<script>
import axios from 'axios'

export default {
  name: 'LoginDialog',
  emits: [ 'hideLogin', 'loginSuccess' ],
  props: [ 'show' ],
  methods: {
    login() {
      axios.post('/auth', this.creds).then(
        (res) => {
          this.$emit('hideLogin')
          this.$emit('loginSuccess', res.data)
        }
      ).catch(
        () => {
          this.loginFailed = true
        }
      )
    }
  },
  data() {
    return {
      valid: false,
      creds: {},
      loginFailed: false,
      emailRules: [ 
        (v) => !v || /^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(v) || 'E-mail must be valid'
      ]
    }
  },
  computed: {
    dialog: {
      get() { return this.show },
      set() { this.$emit('hideLogin') }
    }
  }
}
</script>